/**
 * Abstract Data Type to keep track of a count.
 *
 * @inv {@code getCount() >= 0}
 * 
 * @author Tom Verhoeff (Eindhoven University of Technology)
 */
public class Counter {

    /** Current count */
    private long count;
    
    // ===== Basic Queries =====
    
    /**
     * Gets current count.
     * 
     * @pre {@code true}
     * @modifies None
     * @return number of invocations of {@code count}
     *     since start or last {@code resetCount}
     */
    public long getCount() {
        return count;
    }
    
    // ===== Basic Commands =====
    
    /**
     * Resets count to zero.
     * 
     * @pre {@code true}
     * @modifies {@code this}
     * @post {@code getCount() == 0}
     */
    public void resetCount() {
        count = 0;
    }
    
    /**
     * Counts one up.
     * 
     * @pre {@code true}
     * @modifies {@code this}
     * @post {@code getCount() = \old(getCount() + 1)}
     */
    public void count() {
        ++ count;
    }
    
}