/**
 * Print data passed.
 *
 * @author Tom Verhoeff (Eindhoven University of Technology)
 */
public class DataPrinter implements CallbackB {
    
    /** Name to print in front of each data item. */
    private final String name;
    
    /**
     * Constructs a data printer with given name.
     * 
     * @param name  the name for the data printer
     */
    public DataPrinter(String name) {
        this.name = name;
    }
    
    /**
     * Prints data.
     * 
     * @param data  data item to print
     * @pre {@code true}
     * @modifies None
     * @post {@code data} printed to standard output
     */
    @Override
    public void doB(String data) {
        System.out.println(name + " processed " + data);
    }
    
}