import junit.framework.TestCase;
import java.io.PrintStream;
import java.io.FileNotFoundException;

/**
 * Smoke tests for a data printer.
 */
public class DataPrinterTest extends TestCase {
    
    /**
     * Tests doB().
     */
    public void testDoB() throws FileNotFoundException {
        final String name = "T"; // for printer under test
        final String data = "test"; // argument for doB()
        final String expected = name + " processed " + data;
        final PrintStream oldPS = System.out; // save, to restore
        class TestingPrintStream extends PrintStream {
            TestingPrintStream() throws FileNotFoundException {
                super("/dev/null"); // dump into black hole 
            }
            @Override
            public void println(String x) {
                assertEquals("data", expected, x);
            }
        }
        System.setOut(new TestingPrintStream());
        final DataPrinter printer;
        printer = new DataPrinter("T");
        try {
            printer.doB(data);
        } finally {
            System.setOut(oldPS); // restore from saved
        }
            
    }
    
}
