/**
 * "Complex" functionality A.
 *
 * @author Tom Verhoeff (Eindhoven University of Technology)
 */
public class FunctionalityA {

    /**
     * Produces a number of data items and processes them.
     * 
     * @param n  number of data items to produce
     * @param b  {@code b.doB} processes each data item
     * 
     * @pre {@code 0 <= n && b != null}
     * @modifies whatever {@code b.doB} modifies
     * @post {@code n} data items have been processed by {@code b.doB}
     * @throws AssertionError  if {@code 0 < n}
     * @throws NullPointerException  if {@code b == null}
     */
    public static void doA(int n, CallbackB b) {
        assert 0 <= n : "FunctionalityA.doA: pre n <= 0 failed";
        for (int i = 0; i < n; ++ i) {
            final String data; // data item produced
            data = i + " produced by A"; // "complex" computation
            b.doB(data);
        }
    }
    
}