import junit.framework.TestCase;

/**
 * Smoke tests for functionality A.
 */
public class FunctionalityATest extends TestCase {
    
    /**
     * Tests doA(0, ...).
     */
    public void testDoA0() {
        final CallbackB b = new CallbackB() {
            @Override
            public void doB(String data) {
                fail("b.doB should not have been called");
            }
        };
        FunctionalityA.doA(0, b);
    }
    
     /**
     * Tests doA(1, ...).
     */
    public void testDoA1() {
        final String expected = "0 produced by A";
        final CallbackB b = new CallbackB() {
            @Override
            public void doB(String data) {
                assertEquals("b.doB", expected, data);
            }
        };
        FunctionalityA.doA(1, b);
    }
    
    /**
     * Tests doA() for exception on null callback.
     */
    public void testDoAException() {
        try {
            FunctionalityA.doA(1, null);
            fail("Expected NullPointerException");
        } catch (NullPointerException e) {
            assertTrue(true);
        } catch (Exception e) {
            fail("Expected NullPointerException, but got " + e);
        }
    }
    
}
